//-------------------------------------------------------//
//        Project Code : ESS100K3L-01-19
//           File Name : MCCB.h
//          Created on : 2019. 06. 09.
//         Description :
//              Author : KimJeongWoo
//  Last modified Date :
//-------------------------------------------------------//

#ifndef Relay_H_
#define Relay_H_

#ifdef __cplusplus
extern "C" {
#endif


#pragma SET_DATA_SECTION(".Relay")

extern unsigned FlagAcPreCharge;
extern unsigned FlagBatPreCharge;

extern float AcRelaySetVolt;
extern float BatRelaySetVolt;

extern int StatusAcPreCharge;
extern int StatusBatPreCharge;

extern int CntAcPreChargeWait, SetAcPreChargeWait;
extern int CntBatPreChargeWait, SetBatPreChargeWait;

extern int CntPreAcPreRelayWait, SetPreAcPreRelayWait;
extern int CntPreAcRelayWait, SetPreAcRelayWait;
extern int CntPreAcRelayDetect, SetPreAcRelayDetect;
extern int CntPreAcPreRelayDetect, SetPreAcPreRelayDetect;
extern int CntPreAcRelayDelay, SetPreAcRelayDelay;

extern int CntPreBatPreRelayWait, SetPreBatPreRelayWait;
extern int CntPreBatRelayWait, SetPreBatRelayWait;
extern int CntPreBatRelayDetect, SetPreBatRelayDetect;
extern int CntPreBatPreRelayDetect, SetPreBatPreRelayDetect;
extern int CntPreBatRelayDelay, SetPreBatRelayDelay;

#pragma SET_DATA_SECTION()

extern void PreChargeAcRelay(float AcRelaySetVolt);
extern void PreChargeBatRelay(float BatRelaySetVolt);

extern void InitRelay(void);
extern void InitAcRelay(void);
extern void InitBatRelay(void);
extern void InitRelayTime(void);
extern void InitCntAcPreCharge(void);
extern void InitCntBatPreCharge(void);


#ifdef __cplusplus
}
#endif /* extern "C" */

#endif /* Relay_H_ */
