
//-------------------------------------------------------//
//        Project Code : CodeLibrary
//           File Name : SogiPll3ph.h
//          Created on : 2019. 06. 07.
//         Description :
//              Author : KimJeongWoo
//  Last modified Date :
//-------------------------------------------------------//


#ifndef PLL_SOAPPLL3PH_H_
#define PLL_SOAPPLL3PH_H_


#ifdef __cplusplus
extern "C" {
#endif

//Synchronous Observer-Aided Preprocessing PLL
struct sSoapPll
{
	float Tprd;

	float Kp;
	float Ki;
	float Wc;
	float Zeta;

	float k;
	float rho;
	float c1;
	float c2;

	float ErrVde;
	float ErrVqe;
	float VdePos;
	float VqePos;
	float Vdehat;
	float Vqehat;

	float Thetd;
	float Integral;
	float Wehat;
	float Weff;
	float Thetahat;
	float FreqOut;

	void Init(float mTsamp, float mVsRatePeak, float mFreqRate);
	void Reset(float mEqe_rate, float mFreqRate);
	float Run(float mVde, float mVqe, float mFreqRate, float mTsamp);
	void Preparing(float mVde, float mVqe, float mTheta, float mWeRate);
};


#ifdef __cplusplus
}
#endif // extern "C" //
#endif // MAIN_RESOURCE_INCLUDE_SOAPPLL_H_ //
