//-------------------------------------------------------//
//        Project Code : ALE300K03-21-LGE-GEN2.0-ME-CPU1
//           File Name : Peripherals.h
//          Created on : 2022. 10. 19.
//         Description :
//              Author : Kim-JeongWoo
//  Last modified Date :
//-------------------------------------------------------//

#ifndef MAIN_RESOURCE_LIB_PERIPHERALS_H_
#define MAIN_RESOURCE_LIB_PERIPHERALS_H_

#ifdef __cplusplus
extern "C" {
#endif

//--------------------------Ti Lib------------//
#include "F2837xD_device.h"
#include "driverlib.h"
#include "device.h"
#include "inc/hw_ipc.h"
#include "math.h"
#include "string.h"

#include "fpu_vector.h"

#include "F2837xD_EPwm_defines.h"
//#include "F2837xD_I2c_defines.h"
//--------------------------------------------//

//------------ Board Lib----------------------//
#include "include/CpuInfo.h"
#include "include/AdcLib.h"
#include "include/DigitalIO.h"
#include "include/CanLib.h"
#include "include/EPwmLib.h"
#include "include/TimerLib.h"
#include "include/NtcLib.h"

#include "include/Status.h"
#include "include/SystemVar.h"
#include "include/SensingScale.h"
#include "include/FaultDefine.h"
#include "include/RmsAvgCal.h"

#include <include/Trace.h>

#include "include/F28377D_TempSensor.h"
#include "include/ModBus.h"

//Can 통신 관련
#include "include/CanCHAdeMODataMap.h"
#include "include/CanCHAdeMO.h"

//Eeprom
#include "include/Eeprom.h"
#include "include/SpiEepromLib.h"

#include "include/RTC_SPI.h"

#include "include/RTC.h"


#ifdef __cplusplus
}
#endif /* extern "C" */

#endif /* MAIN_RESOURCE_LIB_PERIPHERALS_H_ */
