//-------------------------------------------------------//
//        Project Code : V2H6K01-23-ENEMAN
//           File Name : CanCHAdeMO.h
//          Created on : 2023. 11. 15.
//         Description :
//              Author : KwonJeongMin
//  Last modified Date :
//-------------------------------------------------------//

#ifndef COMMON_RESOURCE_COMMONLIBRARY_INCLUDE_CANCHADEMO_H_
#define COMMON_RESOURCE_COMMONLIBRARY_INCLUDE_CANCHADEMO_H_

#ifdef __cplusplus
extern "C" {
#endif

#define CanCHAdeMOTxMbox CanaTxMbox
#define CanCHAdeMORxMbox CanaRxMbox

#define CANCHADEMO CANA_BASE

#define CANCHADEMO_SLV_ID_OFFSET 0x100


#pragma SET_DATA_SECTION(".CanCHAData")

extern union uCanCHAdeMO CanCHAdeMO;
extern struct sCanCHAdeMO CanCHAdeMORx;
extern unsigned int CanCHAdeMORxStatus;
extern unsigned int CanCHAdeMORxIsrCnt;
extern unsigned int CanCHAdeMORxIsrErrCnt;

extern unsigned int CanCHAdeMOTxSeqTable[];
extern unsigned int CanCHAdeMOTxSeqTableSize;
extern unsigned int CanCHAdeMOTxSeqTableCnt;

extern unsigned int CANCHADEMO_RxID_OFFSET;
extern unsigned int CANCHADEMO_TxID_OFFSET;

#pragma SET_DATA_SECTION()

extern void InitCanCHAdeMO();

#pragma SET_CODE_SECTION(".TI.ramfunc")

extern void CanCHAdeMORxUpdate();
extern void CanCHAdeMORun_500us();
extern void CanCHAdeMORun();
extern void CanCHAdeMOTxUpdate();
extern void CanCHAdeMOTxMasToSlv();
extern void CanCHAdeMOTxSlvToMas();

extern void CanCHAdeMOMasTxRun();
extern void CanCHAdeMOSlvTxRun();

extern interrupt void CanCHAdeMORxIsr(void);
#pragma SET_CODE_SECTION()

#ifdef __cplusplus
}
#endif /* extern "C" */

#endif /* COMMON_RESOURCE_COMMONLIBRARY_INCLUDE_CANCHADEMO_H_ */
