//-------------------------------------------------------//
//        Project Code : V2H6K01-23-ENEMAN
//           File Name : EepromLib.h
//          Created on : 2023. 10. 31.
//         Description : EEPROM Library for CAT25512VI-GT3
//              Author : "Kim JeongWoo"
//  Last modified Date :
//-------------------------------------------------------//

#ifndef COMMON_RESOURCE_COMMONLIBRARY_INCLUDE_SPIEEPROMLIB_H_
#define COMMON_RESOURCE_COMMONLIBRARY_INCLUDE_SPIEEPROMLIB_H_

#ifdef __cplusplus
extern "C" {
#endif



extern void InitSpi();
extern uint16_t ReadEepromStatusReg(void);

extern void ReadEeprom(uint16_t address, uint16_t *data, uint16_t length);
extern void WriteEepromArray(uint16_t address, uint16_t *data, uint16_t length);
extern void WriteEepromFloat(uint16_t Addr, float *Val);
extern void WriteEepromInt(uint16_t Addr, void *Val);

extern float ReadEepromFloat(uint16_t address, float *Val);
extern int ReadEepromInt(uint16_t address, void *Val);

void WriteEeprom(uint16_t address, uint16_t * data, uint16_t length);

extern int FlagReadEeprom;
extern int FlagWriteEeprom;

extern unsigned int EepromAddr;
extern unsigned int EepromNumofBytes;



#ifdef __cplusplus
}
#endif /* extern "C" */
#endif /* COMMON_RESOURCE_COMMONLIBRARY_INCLUDE_SPIEEPROMLIB_H_ */
