//-------------------------------------------------------//
//        Project Code : ESS100K3L-01-19
//           File Name : SystemVar.h
//          Created on : 2019. 06. 07.
//         Description :
//              Author : KimJeongWoo
//  Last modified Date :
//-------------------------------------------------------//


#ifndef  _SYSTEMVAR_H_
#define  _SYSTEMVAR_H_

#ifdef __cplusplus
extern "C" {
#endif

#define delay_us(us)		DEVICE_DELAY_US(us)
#define delay_ms(ms)		DEVICE_DELAY_US(ms*1000)


#pragma SET_DATA_SECTION(".SystemVar")

extern float SystemClock;



//------------------------------------------------------------------------//

//extern float VdcRate;
//extern float VdcMax;
//extern float VdcMin;
//
//extern float VdabMax;
//extern float VdabMin;
//extern float VdabRate;
//
//extern float VboostRate;
//extern float VboostMin;
//extern float VboostMax;
//
//extern float VbatRate;
//extern float VbatMin;
//extern float VbatMax;

//extern float  INV_Wh_T500ms;
extern int SET_FT_UV_Level;
extern int SET_FT_VIS_Level;
extern int SET_FT_IR_Level;


extern int SystemFault;
extern int EmergencyStop;

extern int CmdFaultReset;

extern float CH1_UV_Flt;
extern float CH1_VIS_Flt;
extern float CH1_IR_Flt;

extern float CH2_UV_Flt;
extern float CH2_VIS_Flt;
extern float CH2_IR_Flt;

extern float CH3_UV_Flt;
extern float CH3_VIS_Flt;
extern float CH3_IR_Flt;

extern float CH4_UV_Flt;
extern float CH4_VIS_Flt;
extern float CH4_IR_Flt;

extern float CH4_UV_max;
extern float CH4_VIS_max;
extern float CH4_IR_max;

extern double uv_vis_correlation;
extern double uv_ir_correlation;
extern double vis_ir_correlation;

extern double uv_vis_change_correlation;
extern double uv_ir_change_correlation;
extern double vis_ir_change_correlation;

extern double FT_uv_vis_correlation;
extern double FT_uv_ir_correlation;
extern double FT_vis_ir_correlation;

extern double FT_uv_vis_change_correlation;
extern double FT_uv_ir_change_correlation;
extern double FT_vis_ir_change_correlation;

extern double stddev;
extern double adaptive_threshold;
extern int latest_change;

extern double FT_stddev;
extern double FT_adaptive_threshold;
extern int FT_latest_change;

extern int SystemReady;
//
//extern int FlagInvGating;
//extern int FlagInvGatingInput;
//
//extern int FlagBoostGating;
//extern int FlagBoostGatingInput;
//
//extern int FlagDabGating;
//extern int FlagDabGatingInput;
//
//extern float Tboost;
//
//extern float TdabPh;
//extern float TdabA;
//extern float TdabB;
//extern float TdabC;
//extern float TdabD;
//
//extern float TinvA;
//extern float TinvB;
//
//extern unsigned int TboostCnt;
//
//extern int TdabPhCnt;
//extern unsigned int TdabACnt;
//extern unsigned int TdabBCnt;
//extern unsigned int TdabCCnt;
//extern unsigned int TdabDCnt;
//
//extern unsigned int TinvACnt;
//extern unsigned int TinvBCnt;

extern int FaultReset;

enum eSystemMode
{
	Normal = 0,
	Test_Mode = 1

};
extern enum eSystemMode ModeSystem;

enum eTestSelect
{
	NonSelect = 0,
	BoardTest = 1,
	StackTest = 2,
	ControllerTest = 3
};

extern enum eTestSelect TestSelect;

enum eSystemState
{
	StateInitial = 0,
	StateOffset = 1,
	StateReady = 2,
	StateRun = 3,
	StateFault = 4
};
extern enum eSystemState SystemState;

enum eINV_OP_MODE
{
	OpMode_GridTie = 0,
	OpMode_StandAlone = 1
};

extern enum eINV_OP_MODE InvOpMode;



extern void InitSystemParameter();
extern void SystemParameterUpdate();



extern struct sRampGen MagVqeRamp;
extern float MagVqeRefSet;
extern float MagSinRef;
extern float DelMagVqe;

extern void FreqSinGen();

extern float ThetaTest;
extern float FreqSineTest;
extern float SinThetaTest;
extern float CosThetaTest;
extern float SinSquareTest;
extern float CosSquareTest;


//TEST

extern float VdcRefSet;
extern float PkwRefSet;


//firmware Ver
extern float FwVer;


#pragma SET_DATA_SECTION()

#pragma SET_DATA_SECTION(".Trace")
extern unsigned long int pTrace1;
extern unsigned long int pTrace2;

extern unsigned int FlagTrace;

extern float TraceData1[2000];
extern float TraceData2[2000];
extern unsigned int TraceCount;

#pragma SET_DATA_SECTION()


#ifdef __cplusplus
}
#endif /* extern "C" */

#endif /*  _SYSTEMVAR_H_ */
