//-------------------------------------------------------//
//        Project Code : ESS100K3L-01-19
//           File Name : ModbusMap.cpp
//          Created on : 2019. 06. 07.
//         Description :
//              Author : KimJeongWoo
//  Last modified Date :
//-------------------------------------------------------//


#include "CommonLib.h"


#pragma SET_DATA_SECTION(".ModbusData")
// Packet1
unsigned char COMM_Operation_Status = 0; // Add : 0 // ON = 0x30 // OFF = 0x31 // Set/Get //*
unsigned char COMM_Installation_location = 1; // Add : 1 // See “2.2 ‘Installation location’ property.” // Set/Get //*
unsigned char COMM_Standard_version_information = 2; // Add : 10 // Get //*
unsigned char COMM_Identification_number = 3; // Add : 12 // Get
unsigned short COMM_Measured_instantaneous_power_consumption = 4; // Add : 21 // Get
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Measured_cumulative_power_consumption_H = 5; // Add : 22 // Get
unsigned char COMM_Measured_cumulative_power_consumption_L = 5; // Add : 23 // Get
// Packet2
unsigned char COMM_Manufacturer_fault_code = 1; // Add : 24 // Get
unsigned char COMM_Current_limit_setting = 2; // Add : 137 // Set/Get
unsigned char COMM_Fault_status = 3; // Add : 138 // Fault = 0x41, No fault = 0x42// Get //*
unsigned short COMM_Fault_description = 4; // Add : 139 // Get
unsigned char COMM_Manufacturer_code = 5; // Add : 140 // Get //*
unsigned char COMM_Business_facility_code = 6; // Add : 142 // Get
unsigned char COMM_Product_code = 7; // Add : 143 // Get
// Packet3
unsigned char COMM_Production_number = 1; // Add : 149 // Get
unsigned char COMM_Production_date = 2; // Add : 155 // Get
unsigned char COMM_Power_saving_operation_setting = 3;// Add : 157 // Set/Get
unsigned char COMM_Remote_control_setting = 4; // Add : 158 // Set/Get
unsigned char COMM_Current_time_setting = 5; // Add : 159 // Set/Get
unsigned char COMM_Current_date_setting = 6; // Add : 161 // Set/Get
unsigned char COMM_Power_limit_setting = 7; // Add : 163 // Set/Get
//long 사이즈 char 사이즈로 변경하기 위해 변수를 3개로 분리
unsigned char COMM_Cumulative_operating_time_1 = 8; // Add : 164 // Get
unsigned char COMM_Cumulative_operating_time_H = 9; // Add : 165 // Get
unsigned char COMM_Cumulative_operating_time_L = 9; // Add : 166 // Get
unsigned char COMM_SetM_property_map = 10; // Add : 167 // Get //*
unsigned char COMM_GetM_property_map = 11; // Add : 176 // Get //*
unsigned char COMM_Status_change_announcement_property_map = 12;// Add : 185 // Get //*
unsigned char COMM_Set_property_map = 13; // Add : 194 // Get //*
unsigned char COMM_Get_property_map = 14; // Add : 203 // Get //*
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Dischargeable_capacity_of_vehicle_mounted_battery_1_H = 15; // Add : 212 // Get //*
unsigned char COMM_Dischargeable_capacity_of_vehicle_mounted_battery_1_L = 15; // Add : 213 // Get //*
unsigned short COMM_Dischargeable_capacity_of_vehicle_mounted_battery_2 = 16; // Add : 214 // Get
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Remaining_dischargeable_capacity_of_vehicle_mounted_battery_1_H = 17; // Add : 215 // Get //*
unsigned char COMM_Remaining_dischargeable_capacity_of_vehicle_mounted_battery_1_L = 17; // Add : 216 // Get //*
unsigned short COMM_Remaining_dischargeable_capacity_of_vehicle_mounted_battery_2 = 18; // Add : 217 // Get
unsigned char COMM_Remaining_dischargeable_capacity_of_vehicle_mounted_battery_3 = 19;// Add : 218 // Get //*
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Rated_charge_capacity_H = 20;// Add : 219 // Get //*
unsigned char COMM_Rated_charge_capacity_L = 20;// Add : 220 // Get //*
unsigned char COMM_Rated_discharge_capacity_H = 21;// Add : 222 // Get //*
unsigned char COMM_Rated_discharge_capacity_L = 21;// Add : 223 // Get //*
unsigned char COMM_Vehicle_connection_and_charge_able_discharge_able_status = 22; // Add : 224 // Get //*
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Minimum_maximum_charging_electric_energy_H = 23;// Add : 225 // Get //*
unsigned char COMM_Minimum_maximum_charging_electric_energy_L = 23;// Add : 226 // Get //*
unsigned char COMM_Minimum_maximum_discharging_electric_energy_H = 24;// Add : 229 // Get //*
unsigned char COMM_Minimum_maximum_discharging_electric_energy_L = 24;// Add : 230 // Get //*
unsigned short COMM_Minimum_maximum_charging_current = 25;// Add : 233 // Get //*
unsigned short COMM_Minimum_maximum_discharging_current = 26;// Add : 235 // Get //*
unsigned char COMM_Charger_discharger_type = 27;// Add : 237 // Get //*
unsigned char COMM_Vehicle_connection_confirmation = 28; // Add : 238 // Get //*
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Chargeable_capacity_of_vehicle_mounted_battery_H = 29;// Add : 239 // Get //*
unsigned char COMM_Chargeable_capacity_of_vehicle_mounted_battery_L = 29;// Add : 240 // Get //*
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Remaining_charg_eable_capacity_of_vehicle_mounted_battery_H = 30;// Add : 241 // Get //*
unsigned char COMM_Remaining_charg_eable_capacity_of_vehicle_mounted_battery_L = 30;// Add : 242 // Get //*
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Used_capacity_of_vehicle_mounted_battery_1_H = 31; // Add : 243 // Get //*
unsigned char COMM_Used_capacity_of_vehicle_mounted_battery_1_L = 31; // Add : 244 // Get //*
unsigned short COMM_Used_capacity_of_vehicle_mounted_battery_2 = 32; // Add : 245 // Get
unsigned short COMM_Rated_voltage = 33; // Add : 246 // Get
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
signed char COMM_Measured_instantaneous_charging_discharging_electric_energy_H = 34; // Add : 247 // Get
signed char COMM_Measured_instantaneous_charging_discharging_electric_energy_L = 34; // Add : 248 // Get
signed short COMM_Measured_instantaneous_charging_discharging_current = 35; // Add : 249 // Get
signed short COMM_Measured_instantaneous_charging_discharging_voltage = 36; // Add : 250 // Get
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Measured_cumulative_amount_of_discharging_electric_energy_H = 37; // Add : 251 // Get
unsigned char COMM_Measured_cumulative_amount_of_discharging_electric_energy_L = 37; // Add : 252 // Get
unsigned short COMM_Cumulative_amount_of_discharging_electric_energy_reset_setting = 38; // Add : 253 // Set
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Measured_cumulative_amount_of_charging_electric_energy_H = 39; // Add : 254 // Get
unsigned char COMM_Measured_cumulative_amount_of_charging_electric_energy_L = 39; // Add : 255 // Get
unsigned char COMM_Cumulative_amount_of_charging_electric_energy_reset_setting = 40; // Add : 256 // Get
unsigned char COMM_Operation_mode_setting = 41; // Add : 257 // Set/Get //*
unsigned char COMM_System_interconnected_type = 42; // Add : 258 // Get
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Remaining_stored_electricity_of_vehicle_mounted_battery_1_H = 43; // Add : 259 // Get //* // Wh
unsigned char COMM_Remaining_stored_electricity_of_vehicle_mounted_battery_1_L = 43; // Add : 260 // Get //* // Wh
unsigned short COMM__Remaining_stored_electricity_of_vehicle_mounted_battery_2 = 44; // Add : 261 // Get // Ah
unsigned char COMM__Remaining_stored_electricity_of_vehicle_mounted_battery_3 = 45; // Add : 262 // Get //* // %
// Packet4
unsigned char COMM_Vehicle_ID = 1; // Add : 263 // Get //*
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Charging_amount_setting_1_H = 2; // Add : 275 // Set/Get
unsigned char COMM_Charging_amount_setting_1_L = 2; // Add : 276 // Set/Get
unsigned short COMM_Charging_amount_setting_2 = 3; // Add : 277 // Set/Get
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Discharging_amount_setting_H = 4; // Add : 278 // Set/Get
unsigned char COMM_Discharging_amount_setting_L = 4; // Add : 279 // Set/Get
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Charging_electric_energy_setting_H = 5; // Add : 280 // Set/Get
unsigned char COMM_Charging_electric_energy_setting_L = 5; // Add : 281 // Set/Get
//long 사이즈 char 사이즈로 변경하기 위해 변수를 2개로 분리
unsigned char COMM_Discharging_electric_energy_setting_H = 6; // Add : 282 // Set/Get
unsigned char COMM_Discharging_electric_energy_setting_L = 6; // Add : 283 // Set/Get
unsigned short COMM_Charging_current_setting = 7; // Add : 284 // Set/Get
unsigned short COMM_Discharging_current_setting = 8; // Add : 285 // Set/Get
unsigned short COMM_Rated_voltage_Independent = 9; // Add : 286 // Get

unsigned char COMM_Operation_status = 1;//Add : 1000//bit0(Stop),bit1(Charge),bit2(Discharge)
unsigned char COMM_Connectrion_state = 1;//Add : 1001//bit0(Disconnect),bit1(Connect)
unsigned char COMM_SOC;//Add : 1002//0x00-0x64 (0 - 100%)
unsigned char COMM_Instantaneous_power;//Add : 1003//0x00-0x63 (0 - 99)  (ex> 8.9kW = 89)


//todo 테스트용
int idummy = 0;

#pragma SET_DATA_SECTION()


void InitModbusPtr()
{
	unsigned int i = 0;

	for (i = 0; i < MODBUSAPTRMAX; i++) ModbusAPtr[i] = &idummy;

#if(MODBUSA_ENB)
	InitModbusAPtr();
#endif

#if(MODBUSB_ENB)
	InitModbusBPtr();
#endif

}

void ModbusATxDataUpdate()
{

}

void ModbusARxDataUpdate()
{
	COMM_Instantaneous_power = PbatAvg;

}

void InitModbusAPtr()
{

    // Packet1
    ModbusAPtr[0] = &COMM_Operation_Status;
    ModbusAPtr[1] = &COMM_Installation_location;
//    ModbusAPtr[2] = &idummy;
//    ModbusAPtr[3] = &idummy;
//    ModbusAPtr[4] = &idummy;
//    ModbusAPtr[5] = &idummy;
//    ModbusAPtr[6] = &idummy;
//    ModbusAPtr[7] = &idummy;
//    ModbusAPtr[8] = &idummy;
//    ModbusAPtr[9] = &idummy;

    ModbusAPtr[10] = &COMM_Standard_version_information;
//    ModbusAPtr[11] = &idummy;
    ModbusAPtr[12] = &COMM_Identification_number;
//    ModbusAPtr[13] = &idummy;
//    ModbusAPtr[14] = &idummy;
//    ModbusAPtr[15] = &idummy;
//    ModbusAPtr[16] = &idummy;
//    ModbusAPtr[17] = &idummy;
//    ModbusAPtr[18] = &idummy;
//    ModbusAPtr[19] = &idummy;

//    ModbusAPtr[20] = &idummy;
    ModbusAPtr[21] = &COMM_Measured_instantaneous_power_consumption;
    ModbusAPtr[22] = &COMM_Measured_cumulative_power_consumption_H;
    ModbusAPtr[23] = &COMM_Measured_cumulative_power_consumption_L;

    // Packet2
    ModbusAPtr[24] = &COMM_Manufacturer_fault_code;
//    ModbusAPtr[25] = &idummy;
//    ModbusAPtr[26] = &idummy;
//    ModbusAPtr[27] = &idummy;
//    ModbusAPtr[28] = &idummy;
//    ModbusAPtr[29] = &idummy;
//
//    ModbusAPtr[30] = &idummy;
//    ModbusAPtr[31] = &idummy;
//    ModbusAPtr[32] = &idummy;
//    ModbusAPtr[33] = &idummy;
//    ModbusAPtr[34] = &idummy;
//    ModbusAPtr[35] = &idummy;
//    ModbusAPtr[36] = &idummy;
//    ModbusAPtr[37] = &idummy;
//    ModbusAPtr[38] = &idummy;
//    ModbusAPtr[39] = &idummy;
//
//    ModbusAPtr[40] = &idummy;
//    ModbusAPtr[41] = &idummy;
//    ModbusAPtr[42] = &idummy;
//    ModbusAPtr[43] = &idummy;
//    ModbusAPtr[44] = &idummy;
//    ModbusAPtr[45] = &idummy;
//    ModbusAPtr[46] = &idummy;
//    ModbusAPtr[47] = &idummy;
//    ModbusAPtr[48] = &idummy;
//    ModbusAPtr[49] = &idummy;
//
//    ModbusAPtr[50] = &idummy;
//    ModbusAPtr[51] = &idummy;
//    ModbusAPtr[52] = &idummy;
//    ModbusAPtr[53] = &idummy;
//    ModbusAPtr[54] = &idummy;
//    ModbusAPtr[55] = &idummy;
//    ModbusAPtr[56] = &idummy;
//    ModbusAPtr[57] = &idummy;
//    ModbusAPtr[58] = &idummy;
//    ModbusAPtr[59] = &idummy;
//
//    ModbusAPtr[60] = &idummy;
//    ModbusAPtr[61] = &idummy;
//    ModbusAPtr[62] = &idummy;
//    ModbusAPtr[63] = &idummy;
//    ModbusAPtr[64] = &idummy;
//    ModbusAPtr[65] = &idummy;
//    ModbusAPtr[66] = &idummy;
//    ModbusAPtr[67] = &idummy;
//    ModbusAPtr[68] = &idummy;
//    ModbusAPtr[69] = &idummy;
//
//    ModbusAPtr[70] = &idummy;
//    ModbusAPtr[71] = &idummy;
//    ModbusAPtr[72] = &idummy;
//    ModbusAPtr[73] = &idummy;
//    ModbusAPtr[74] = &idummy;
//    ModbusAPtr[75] = &idummy;
//    ModbusAPtr[76] = &idummy;
//    ModbusAPtr[77] = &idummy;
//    ModbusAPtr[78] = &idummy;
//    ModbusAPtr[79] = &idummy;
//
//    ModbusAPtr[80] = &idummy;
//    ModbusAPtr[81] = &idummy;
//    ModbusAPtr[82] = &idummy;
//    ModbusAPtr[83] = &idummy;
//    ModbusAPtr[84] = &idummy;
//    ModbusAPtr[85] = &idummy;
//    ModbusAPtr[86] = &idummy;
//    ModbusAPtr[87] = &idummy;
//    ModbusAPtr[88] = &idummy;
//    ModbusAPtr[89] = &idummy;
//
//    ModbusAPtr[90] = &idummy;
//    ModbusAPtr[91] = &idummy;
//    ModbusAPtr[92] = &idummy;
//    ModbusAPtr[93] = &idummy;
//    ModbusAPtr[94] = &idummy;
//    ModbusAPtr[95] = &idummy;
//    ModbusAPtr[96] = &idummy;
//    ModbusAPtr[97] = &idummy;
//    ModbusAPtr[98] = &idummy;
//    ModbusAPtr[99] = &idummy;
//
//    ModbusAPtr[100] = &idummy;
//    ModbusAPtr[101] = &idummy;
//    ModbusAPtr[102] = &idummy;
//    ModbusAPtr[103] = &idummy;
//    ModbusAPtr[104] = &idummy;
//    ModbusAPtr[105] = &idummy;
//    ModbusAPtr[106] = &idummy;
//    ModbusAPtr[107] = &idummy;
//    ModbusAPtr[108] = &idummy;
//    ModbusAPtr[109] = &idummy;
//
//    ModbusAPtr[110] = &idummy;
//    ModbusAPtr[111] = &idummy;
//    ModbusAPtr[112] = &idummy;
//    ModbusAPtr[113] = &idummy;
//    ModbusAPtr[114] = &idummy;
//    ModbusAPtr[115] = &idummy;
//    ModbusAPtr[116] = &idummy;
//    ModbusAPtr[117] = &idummy;
//    ModbusAPtr[118] = &idummy;
//    ModbusAPtr[119] = &idummy;
//
//    ModbusAPtr[120] = &idummy;
//    ModbusAPtr[121] = &idummy;
//    ModbusAPtr[122] = &idummy;
//    ModbusAPtr[123] = &idummy;
//    ModbusAPtr[124] = &idummy;
//    ModbusAPtr[125] = &idummy;
//    ModbusAPtr[126] = &idummy;
//    ModbusAPtr[127] = &idummy;
//    ModbusAPtr[128] = &idummy;
//    ModbusAPtr[129] = &idummy;
//
//    ModbusAPtr[130] = &idummy;
//    ModbusAPtr[131] = &idummy;
//    ModbusAPtr[132] = &idummy;
//    ModbusAPtr[133] = &idummy;
//    ModbusAPtr[134] = &idummy;
//    ModbusAPtr[135] = &idummy;
//    ModbusAPtr[136] = &idummy;
    ModbusAPtr[137] = &COMM_Current_limit_setting;
    ModbusAPtr[138] = &COMM_Fault_status;
    ModbusAPtr[139] = &COMM_Fault_description;

    ModbusAPtr[140] = &COMM_Manufacturer_code;
//    ModbusAPtr[141] = &idummy;
    ModbusAPtr[142] = &COMM_Business_facility_code;
    ModbusAPtr[143] = &COMM_Product_code;
//    ModbusAPtr[144] = &idummy;
//    ModbusAPtr[145] = &idummy;
//    ModbusAPtr[146] = &idummy;
//    ModbusAPtr[147] = &idummy;
//    ModbusAPtr[148] = &idummy;

    // Packet3
    ModbusAPtr[149] = &COMM_Production_number;

//    ModbusAPtr[150] = &idummy;
//    ModbusAPtr[151] = &idummy;
//    ModbusAPtr[152] = &idummy;
//    ModbusAPtr[153] = &idummy;
//    ModbusAPtr[154] = &idummy;
    ModbusAPtr[155] = &COMM_Production_date;
//    ModbusAPtr[156] = &idummy;
    ModbusAPtr[157] = &COMM_Power_saving_operation_setting;
    ModbusAPtr[158] = &COMM_Remote_control_setting;
    ModbusAPtr[159] = &COMM_Current_time_setting;

    ModbusAPtr[160] = &COMM_Current_date_setting;
    ModbusAPtr[161] = &COMM_Current_date_setting;
    ModbusAPtr[162] = &COMM_Power_limit_setting;
    ModbusAPtr[163] = &COMM_Cumulative_operating_time_1;
    ModbusAPtr[164] = &COMM_Cumulative_operating_time_H;
    ModbusAPtr[165] = &COMM_Cumulative_operating_time_L;
    ModbusAPtr[166] = &COMM_SetM_property_map;
//    ModbusAPtr[167] = &idummy;
//    ModbusAPtr[168] = &idummy;
//    ModbusAPtr[169] = &idummy;
//
//    ModbusAPtr[170] = &idummy;
//    ModbusAPtr[171] = &idummy;
//    ModbusAPtr[172] = &idummy;
//    ModbusAPtr[173] = &idummy;
//    ModbusAPtr[174] = &idummy;
    ModbusAPtr[175] = &COMM_GetM_property_map;
//    ModbusAPtr[176] = &idummy;
//    ModbusAPtr[177] = &idummy;
//    ModbusAPtr[178] = &idummy;
//    ModbusAPtr[179] = &idummy;

//    ModbusAPtr[180] = &idummy;
//    ModbusAPtr[181] = &idummy;
//    ModbusAPtr[182] = &idummy;
//    ModbusAPtr[183] = &idummy;
    ModbusAPtr[184] = &COMM_Status_change_announcement_property_map;
//    ModbusAPtr[185] = &idummy;
//    ModbusAPtr[186] = &idummy;
//    ModbusAPtr[187] = &idummy;
//    ModbusAPtr[188] = &idummy;
//    ModbusAPtr[189] = &idummy;

//    ModbusAPtr[190] = &idummy;
//    ModbusAPtr[191] = &idummy;
//    ModbusAPtr[192] = &idummy;
    ModbusAPtr[193] = &COMM_Set_property_map;
//    ModbusAPtr[194] = &idummy;
//    ModbusAPtr[195] = &idummy;
//    ModbusAPtr[196] = &idummy;
//    ModbusAPtr[197] = &idummy;
//    ModbusAPtr[198] = &idummy;
//    ModbusAPtr[199] = &idummy;

//    ModbusAPtr[200] = &idummy;
//    ModbusAPtr[201] = &idummy;
    ModbusAPtr[202] = &COMM_Get_property_map;
//    ModbusAPtr[203] = &idummy;
//    ModbusAPtr[204] = &idummy;
//    ModbusAPtr[205] = &idummy;
//    ModbusAPtr[206] = &idummy;
//    ModbusAPtr[207] = &idummy;
//    ModbusAPtr[208] = &idummy;
//    ModbusAPtr[209] = &idummy;

//    ModbusAPtr[210] = &idummy;
    ModbusAPtr[211] = &COMM_Dischargeable_capacity_of_vehicle_mounted_battery_1_H;
    ModbusAPtr[212] = &COMM_Dischargeable_capacity_of_vehicle_mounted_battery_1_L;
    ModbusAPtr[213] = &COMM_Dischargeable_capacity_of_vehicle_mounted_battery_2;
    ModbusAPtr[214] = &COMM_Remaining_dischargeable_capacity_of_vehicle_mounted_battery_1_H;
    ModbusAPtr[215] = &COMM_Remaining_dischargeable_capacity_of_vehicle_mounted_battery_1_L;
    ModbusAPtr[216] = &COMM_Remaining_dischargeable_capacity_of_vehicle_mounted_battery_2;
    ModbusAPtr[217] = &COMM_Remaining_dischargeable_capacity_of_vehicle_mounted_battery_3;
    ModbusAPtr[218] = &COMM_Rated_charge_capacity_H;
    ModbusAPtr[219] = &COMM_Rated_charge_capacity_L;

    ModbusAPtr[220] = &COMM_Rated_discharge_capacity_H;
    ModbusAPtr[221] = &COMM_Rated_discharge_capacity_L;
    ModbusAPtr[222] = &COMM_Vehicle_connection_and_charge_able_discharge_able_status;
    ModbusAPtr[223] = &COMM_Minimum_maximum_charging_electric_energy_H;
    ModbusAPtr[224] = &COMM_Minimum_maximum_charging_electric_energy_L;
//    ModbusAPtr[225] = &idummy;
//    ModbusAPtr[226] = &idummy;
    ModbusAPtr[227] = &COMM_Minimum_maximum_discharging_electric_energy_H;
    ModbusAPtr[228] = &COMM_Minimum_maximum_discharging_electric_energy_L;
//    ModbusAPtr[229] = &idummy;

//    ModbusAPtr[230] = &idummy;
    ModbusAPtr[231] = &COMM_Minimum_maximum_charging_current;
//    ModbusAPtr[232] = &idummy;
    ModbusAPtr[233] = &COMM_Minimum_maximum_discharging_current;
//    ModbusAPtr[234] = &idummy;
    ModbusAPtr[235] = &COMM_Charger_discharger_type;
    ModbusAPtr[236] = &COMM_Vehicle_connection_confirmation;
    ModbusAPtr[237] = &COMM_Chargeable_capacity_of_vehicle_mounted_battery_H;
    ModbusAPtr[238] = &COMM_Chargeable_capacity_of_vehicle_mounted_battery_L;
    ModbusAPtr[239] = &COMM_Remaining_charg_eable_capacity_of_vehicle_mounted_battery_H;

    ModbusAPtr[240] = &COMM_Remaining_charg_eable_capacity_of_vehicle_mounted_battery_L;
    ModbusAPtr[241] = &COMM_Used_capacity_of_vehicle_mounted_battery_1_H;
    ModbusAPtr[242] = &COMM_Used_capacity_of_vehicle_mounted_battery_1_L;
    ModbusAPtr[243] = &COMM_Used_capacity_of_vehicle_mounted_battery_2;
    ModbusAPtr[244] = &COMM_Rated_voltage;
    ModbusAPtr[245] = &COMM_Measured_instantaneous_charging_discharging_electric_energy_H;
    ModbusAPtr[246] = &COMM_Measured_instantaneous_charging_discharging_electric_energy_L;
    ModbusAPtr[247] = &COMM_Measured_instantaneous_charging_discharging_current;
    ModbusAPtr[248] = &COMM_Measured_instantaneous_charging_discharging_voltage;
    ModbusAPtr[249] = &COMM_Measured_cumulative_amount_of_discharging_electric_energy_H;

    ModbusAPtr[250] = &COMM_Measured_cumulative_amount_of_discharging_electric_energy_L;
    ModbusAPtr[251] = &COMM_Cumulative_amount_of_discharging_electric_energy_reset_setting;
    ModbusAPtr[252] = &COMM_Measured_cumulative_amount_of_charging_electric_energy_H;
    ModbusAPtr[253] = &COMM_Measured_cumulative_amount_of_charging_electric_energy_L;
    ModbusAPtr[254] = &COMM_Cumulative_amount_of_charging_electric_energy_reset_setting;
    ModbusAPtr[255] = &COMM_Operation_mode_setting;
    ModbusAPtr[256] = &COMM_System_interconnected_type;
    ModbusAPtr[257] = &COMM_Remaining_stored_electricity_of_vehicle_mounted_battery_1_H;
    ModbusAPtr[258] = &COMM_Remaining_stored_electricity_of_vehicle_mounted_battery_1_L;
    ModbusAPtr[259] = &COMM__Remaining_stored_electricity_of_vehicle_mounted_battery_2;

    ModbusAPtr[260] = &COMM__Remaining_stored_electricity_of_vehicle_mounted_battery_3;
    ModbusAPtr[261] = &COMM_Vehicle_ID;
//    ModbusAPtr[262] = &idummy;

    // Packet4
//    ModbusAPtr[263] = &idummy;
//    ModbusAPtr[264] = &idummy;
//    ModbusAPtr[265] = &idummy;
//    ModbusAPtr[266] = &idummy;
//    ModbusAPtr[267] = &idummy;
//    ModbusAPtr[268] = &idummy;
//    ModbusAPtr[269] = &idummy;

//    ModbusAPtr[270] = &idummy;
//    ModbusAPtr[271] = &idummy;
//    ModbusAPtr[272] = &idummy;
    ModbusAPtr[273] = &COMM_Charging_amount_setting_1_H;
    ModbusAPtr[274] = &COMM_Charging_amount_setting_1_L;
    ModbusAPtr[275] = &COMM_Charging_amount_setting_2;
    ModbusAPtr[276] = &COMM_Discharging_amount_setting_H;
    ModbusAPtr[277] = &COMM_Discharging_amount_setting_L;
    ModbusAPtr[278] = &COMM_Charging_electric_energy_setting_H;
    ModbusAPtr[279] = &COMM_Charging_electric_energy_setting_L;

    ModbusAPtr[280] = &COMM_Discharging_electric_energy_setting_H;
    ModbusAPtr[281] = &COMM_Discharging_electric_energy_setting_L;
    ModbusAPtr[282] = &COMM_Charging_current_setting;
    ModbusAPtr[283] = &COMM_Discharging_current_setting;
    ModbusAPtr[284] = &COMM_Rated_voltage_Independent;
//    ModbusAPtr[285] = &idummy;
//    ModbusAPtr[286] = &idummy;

//---------------------------------------------//

//    ModbusAPtr[287] = &idummy;
//    ModbusAPtr[288] = &idummy;
//    ModbusAPtr[289] = &idummy;

    ModbusAPtr[1000] = &COMM_Operation_status;
    ModbusAPtr[1001] = &COMM_Connectrion_state;
    ModbusAPtr[1002] = &COMM_SOC;
    ModbusAPtr[1003] = &COMM_Instantaneous_power;
}

void ModbusBTxDataUpdate()
{

}

void ModbusBRxDataUpdate()
{

}

void InitModbusBPtr()
{


}



