//-------------------------------------------------------//
//        Project Code : ALE300K03-21-LGE-GEN2.0-ME-CPU1
//           File Name : Ntc.cpp
//          Created on : 2022. 10. 17.
//         Description :
//              Author : KimJeongWoo
//  Last modified Date :
//-------------------------------------------------------//


#include <CommonLib.h>

sNTCTABLE NtcHeatSink;


sTEMP_LIST Temp;

void InitNtcTable()
{
    memset(&NtcHeatSink, 0, (sizeof(NtcHeatSink) / sizeof(int)));

    //내기온도 측정용 : NTCALUG02A103G
    //Beta(25/85) = 3984
    //Tolerance R +-2%
    NtcHeatSink.R25 = 10000.;
    NtcHeatSink.Rset = 20000.;
    NtcHeatSink.Vset = 3.;
    NtcHeatSink.Beta = 3984.;
    NtcHeatSink.TempStep = 1;
    NtcHeatSink.Size = 200;

    NtcTableGen(&NtcHeatSink);

}



void NtcRead()
{
	NtcTableReadTemp(&Temp.DcSwHeatSink1,	&Adc.Data[15],	&NtcHeatSink);
	NtcTableReadTemp(&Temp.DcSwHeatSink2,	&Adc.Data[16],	&NtcHeatSink);
//	NtcTableReadTemp(&Temp.AcSwHeatSink1,	&Adc.Data[24],	&NtcHeatSink);
//	NtcTableReadTemp(&Temp.AcSwHeatSink2,	&Adc.Data[25],	&NtcHeatSink);
//	NtcTableReadTemp(&Temp.Spare1,			&Adc.Data[26],	&NtcHeatSink);
//	NtcTableReadTemp(&Temp.Spare2,			&Adc.Data[27],	&NtcHeatSink);

	Temp.MCU = (float)GetTemperatureC(AdcaResultRegs.ADCRESULT8);
}
